/* 
 *  icqserv
 *  Justin Hammond, 1999
 *  Dynamx Internet Services
 *  Comment: Added icqserv to statserv services for irc!
 ******************************************************************************
 *   Version: 0.01 
 *
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h>
#include <time.h>

#include "icq.h"
#include "icqconfig.h"

struct uin_info
{
   unsigned long uin;
   int replied;
   char message[MAX_MSG_LENGTH];
   int category;
   long senttime;
};

static int login_ok=0;
char *msg, *msgx;

void statserv(char *line)
{
	char *cmd, *nick = strtok(line, " ");
	User *u;
	
	nick++;
	cmd = strtok(NULL, " ");
	cmd = strtok(NULL, " ");
	cmd = strtok(NULL, " ");
	cmd++;
	u = finduser(nick);
	if (!u) {
		log("Unable to finduser %s (statserv)", nick);
		return;
	}

	me.requests++;

	if (flood(u))
		return;

	log("%s received message from %s: %s", s_StatServ, nick, cmd);
 
	if (me.onlyopers && !u->is_oper) {
		privmsg(u->nick, s_StatServ,
			"This service is only available to IRCops.");
		notice ("%s Requested %s, but he is Not a Operator!", u->nick, cmd);
		return;
	}

	if (!strcasecmp(cmd, "HELP")) {
		cmd = strtok(NULL, " ");
		notice("%s is a Dummy and wanted help on %s",u->nick, cmd);
		if (!cmd) {
			privmsg_list(nick, s_StatServ, ss_help);
			if (u->myuser != NULL)
				privmsg_list(nick, s_StatServ, ss_myuser_help);
		} else if (!strcasecmp(cmd, "SERVER"))
			privmsg_list(nick, s_StatServ, ss_server_help);
		else if (!strcasecmp(cmd, "MAP"))
			privmsg_list(nick, s_StatServ, ss_map_help);
		else if (!strcasecmp(cmd, "NETSTATS"))
			privmsg_list(nick, s_StatServ, ss_netstats_help);
		else if (!strcasecmp(cmd, "DAILY"))
			privmsg_list(nick, s_StatServ, ss_daily_help);
		else if (!strcasecmp(cmd, "TLD"))
			privmsg_list(nick, s_StatServ, ss_tld_help);
		else if (!strcasecmp(cmd, "TLDMAP"))
			privmsg_list(nick, s_StatServ, ss_tld_map_help);
		else if (!strcasecmp(cmd, "OPERLIST"))
			privmsg_list(nick, s_StatServ, ss_operlist_help);
                else if (!strcasecmp(cmd, "VERSION"))
                        privmsg_list(nick, s_StatServ, ss_version_help);
		else if (!strcasecmp(cmd, "LOGIN"))
			privmsg_list(nick, s_StatServ, ss_login_help);
		else if (!strcasecmp(cmd, "SHUTDOWN") && u->myuser)
			privmsg_list(nick, s_StatServ, ss_shutdown_help);
		else if (!strcasecmp(cmd, "USER") && u->myuser)
			privmsg_list(nick, s_StatServ, ss_user_help);
		else if (!strcasecmp(cmd, "STATS") && u->myuser)
			privmsg_list(nick, s_StatServ, ss_stats_help);
		else if (!strcasecmp(cmd, "LOGS") && u->myuser)
			privmsg_list(nick, s_StatServ, ss_logs_help);
		else if (!strcasecmp(cmd, "JOIN") && u->myuser)
			privmsg_list(nick, s_StatServ, ss_join_help);
		else
			privmsg(nick, s_StatServ, "Unknown Help Topic: \2%s\2",
				cmd);
	} else if (!strcasecmp(cmd, "SERVER")) {
		cmd = strtok(NULL, " ");
		ss_server(u, cmd);
		notice("%s Wanted Server Information on %s",u->nick, cmd);
	} else if (!strcasecmp(cmd, "MAP")) {
		ss_map(u);
		notice("%s Wanted to see the Current Network MAP",u->nick);		
	} else if (!strcasecmp(cmd, "UPTIME")) {
		ss_uptime(u);
		notice("%s Wanted to see %s's Uptime ",me.name,u->nick);
	} else if (!strcasecmp(cmd, "NETSTATS")) {
		ss_netstats(u);
		notice("%s Wanted to see the NetStats ",u->nick);
	} else if (!strcasecmp(cmd, "DAILY")) {
		ss_daily(u);
		notice("%s Wanted to see the Daily NetStats ",u->nick);
	} else if (!strcasecmp(cmd, "TLD")) {
		cmd = strtok(NULL, " ");
		ss_tld(u, cmd);
		notice("%s Wanted to find the Country that is Represented by %s ",u->nick,cmd);
	} else if (!strcasecmp(cmd, "TLDMAP")) {
		ss_tld_map(u);
		notice("%s Wanted to see a Country Breakdown",u->nick);
	} else if (!strcasecmp(cmd, "OPERLIST")) {
		char *t;
		cmd = strtok(NULL, " ");
		t = strtok(NULL, " ");
		ss_operlist(u, cmd, t);
		notice("%s Wanted to see The Current Operator list ",u->nick);
        } else if (!strcasecmp(cmd, "VERSION")) {
                ss_version(u);
                notice("%s Wanted to see our current version");
	} else if (!strcasecmp(cmd, "LOGIN")) {
		char *t;
		cmd = strtok(NULL, " ");
		t = strtok(NULL, " ");
		ss_login(u, cmd, t);
	} else if (!strcasecmp(cmd, "USER")) {
		char *t, *m;
		m = strtok(NULL, " ");
		cmd = strtok(NULL, " ");
		t = strtok(NULL, " ");
		ss_user(u, m, cmd, t);
		notice("%s Has Created a New Login for %s ",u->nick,m);
	} else if (!strcasecmp(cmd, "SHUTDOWN")) {
		notice("%s Wants me to Go to BED!!! Good Night!",u->nick);
		ss_shutdown(u);
	} else if (!strcasecmp(cmd, "STATS")) {
		char *t, *m;
		m = strtok(NULL, " ");
		cmd = strtok(NULL, " ");
		t = strtok(NULL, " ");
		ss_stats(u, m, cmd, t);
		notice("%s Wants to Look at my Stats!! 34/24/34",u->nick);
	} else if (!strcasecmp(cmd, "LOGS")) {
		ss_logs(u);
		notice("%s Wants to Look at my Logs!!",u->nick);
	} else if (!strcasecmp(cmd, "JUPE")) {
		cmd = strtok(NULL, " ");
		ss_jupe(u, cmd);
		notice("%s Wants to JUPE this Server %s",u->nick,cmd);
	} else if (!strcasecmp(cmd, "JOIN")) {
		cmd = strtok(NULL, " ");
		ss_JOIN(u, cmd);
	} else {
		privmsg(nick, s_StatServ, "Unknown Command: \2%s\2",
			cmd);
		notice("%s Reqested %s, but that is a Unknown Command",u->nick,cmd);
	}
}




static int doICQProtocol()
{
    fd_set rfds;
    int    sok=icq_GetSok();
    struct timeval tv;

    int time_to_ping          = KEEP_ALIVE_DELAY ;
    int time_to_login_timeout = LOGIN_DELAY      ;

    time_t start;
    time_t end  ;
    
    while(1)
    {
        FD_ZERO(&rfds);
        FD_SET(sok, &rfds);
        tv.tv_sec  = time_to_ping;
        if(!login_ok && tv.tv_sec>time_to_login_timeout)
            tv.tv_sec  = time_to_login_timeout;
        tv.tv_usec = 0;
        
        start  = time(NULL);
        if(select(sok+1, &rfds, NULL, NULL, &tv)==-1)
        {
            printf("<P>The Following Message Was Sent!</P>\n");
	    printf("<P>%s</P>\n", msgx);
	    puts("</BODY>\n</HTML>");
            return 1;
        }
        end    = time(NULL);
        
        if(FD_ISSET(sok, &rfds))
            icq_HandleServerResponse();
 
        time_to_ping-=(end-start);
        if(time_to_ping<=0)
        {
            icq_KeepAlive();
            time_to_ping=KEEP_ALIVE_DELAY;
        }
        
        if(!login_ok)
        {
            time_to_login_timeout-=(end-start);
            if(time_to_login_timeout<=0)
            {
                printf("<P>Login timeout. Exiting.</P>\n");
		puts("</BODY>\n</HTML>");
                return 1;
            }
        }
    }
    return 0;
}

static int do_connect(const char *server, int port)
{
    printf("<P>Connecting to: %s:%d</P>\n",server,port);
    icq_UnsetProxy();
    return icq_Connect(server,port);
}

static void login(unsigned long status,
                  unsigned long uin,
                  const char *pass)
{
    char buf[9];
    
    printf("<P>Trying to contact ...</P>\n");
    if (strlen(pass) > 8)
       strncpy(buf, pass, 8);
    else
       strcpy(buf, pass);

    icq_Init(uin, buf);
    icq_Login(status);
}

void loginOK()
{
   login_ok=1;
   printf("<P>Login OK.</P>\n");
   icq_SendMessage(atol(config.ruin), msgx);
   icq_ChangeStatus(STATUS_OFFLINE);
   icq_Logout();
   icq_Disconnect();
}

void connectionLost()
{
    printf("<P>Connection to server lost. Exiting.</P>\n");
    exit(8);
}

void RespondAuthReq (unsigned long uin,
                     unsigned char hour,
                     unsigned char minute,
                     unsigned char day,
                     unsigned char month,
                     unsigned short year,
                     const char *nick,
                     const char *first,
                     const char *last,
                     const char *email,
                     const char *reason)
{
    fprintf(stderr, "Authorization request received from %ld. Reason: %s\n", uin, reason);
    icq_SendAuthMsg(uin);
}

void doLog(time_t time, unsigned char level, const char *str)
{
    printf("<P>AuroreMsg:%d %s</P>\n",(int) level, str);
}

int main(void)
{
  ROOT *root;

  puts("Content-type: text/html\n\n");
  puts("<HTML>\n<HEAD>\n<TITLE>CGICQ :: Trying to send your message</TITLE>\n</HEAD>\n<BODY>\n");
  parse(&root);
  msg = get_node(&root, "msg");

  icq_Logged = loginOK;
  icq_Log = doLog;
  icq_LogLevel = ICQ_LOG_WARNING;
  icq_Disconnected = connectionLost;
  icq_RecvAuthReq = RespondAuthReq;

  if (getenv("REMOTE_HOST"))
     {
       msgx = malloc(strlen(msg)+strlen(getenv("REMOTE_HOST"))+5+strlen(getenv("HTTP_USER_AGENT"))+5);
       sprintf(msgx, "%s - %s\x0D%s", msg, getenv("REMOTE_HOST"), getenv("HTTP_USER_AGENT"));
     } else {
       msgx = malloc(strlen(msg)+strlen(getenv("REMOTE_ADDR"))+5+strlen(getenv("HTTP_USER_AGENT"))+5);
       sprintf(msgx, "%s - %s\x0D%s", msg, getenv("REMOTE_ADDR"),  getenv("HTTP_USER_AGENT"));
   }

  if (!get_config(&config, CONF_FILE)) {
	printf("get_config() returned 0, Fatal Error!\n");
	exit(1);
  }
  
   if(do_connect(config.server, atoi(config.port)) != -1)
   {
      login(STATUS_ONLINE, atol(config.suin), config.passwd);
      return doICQProtocol();
   }
   else
   {
      printf("<P>Can't connect to server: %s:%d</P>\n",config.server, atoi(config.port));
      return 1;
   }
   
   free(msgx); 
   puts("</BODY>\n</HTML>");
   return 0;
}
