/* NetStats - IRC Statistical Services
** Copyright (c) 1999 Adam Rutter, Justin Hammond
** http://codeworks.kamserve.com
*
** Based from GeoStats 1.1.0 by Johnathan George net@lite.net
*
** NetStats CVS Identification
** $Id$
*/

#include "stats.h"
extern const char version_date[], version_time[];
extern const char protocol_version[];


static void ShowMOTD(char *);
static void Showcredits(char *);

void parse(char *line)
{
	char *origin, *cmd, *coreLine;
	int cmdptr = 0;

	strip(line);

	if (!(*line))
		return;

	coreLine = strdup(line);

#ifdef DEBUG
	log("R: %s", line);
#endif
	origin = strtok(line, " ");
	if (*origin == ':')
		cmdptr = 1;
	cmd = strtok(NULL, " ");

	if (cmdptr) {
		origin++;
		if (!strcmp(cmd, "VERSION")) {
			sts(":%s 351 %s %s :%s -> %s %s", me.name, origin, version,
				me.name, version_date, version_time);
		} else if (!strcmp(cmd, "MOTD")) {
			ShowMOTD(origin);
		} else if (!strcmp(cmd, "CREDITS")) {
			Showcredits(origin);
		} else if (!strcmp(cmd, "PRIVMSG")) {
			cmd = strtok(NULL, " ");
			if (!strcasecmp(cmd, s_StatServ))
				statserv(coreLine);
			else if (!strcasecmp(cmd, s_Spam) && me.enable_spam)
				spam(coreLine);
			/* else if (!strcasecmp(cmd, s_Icq ) && me.enable_icq )
			**
			**	icq(coreline);
			*/
		} else if (!strcmp(cmd, "SERVER")) {
			cmd = strtok(NULL, " ");
			AddServer(cmd, 1);
			notice("\2Server\2 -(\2%s\2)- Has Joined the Network at: %s",cmd,origin);
		} else if (!strcmp(cmd, "SQUIT")) {
			Server *s;
			cmd = strtok(NULL, " ");
			if ((s = findserver(cmd))) s->stats->numsplits++;
			DelServer(cmd);
			notice("\2Possible NetSplit at: %s -> %s (Split)\2",origin,cmd);
		} else if (!strcmp(cmd, "QUIT")) {
			DelUser(origin);
			cmd = strtok(NULL, "");
			cmd++;
			notice("\2SIGNOFF:\2 \2%s\2-->(%s)",origin,cmd);
		} else if (!strcmp(cmd, "MODE")) {
			cmd = strtok(NULL, " ");
			if (!strchr(cmd, '#')) {
				cmd = strtok(NULL, "");
				UserMode(origin, cmd);
			}
                } else if (!strcmp(cmd, "SVSMODE")) {
                        char *u;
                        cmd = strtok(NULL, " ");
                        u = strtok(NULL, " ");
                        if (!strchr(cmd, '#')) {
                                UserMode(cmd,u);
                        }
		} else if (!strcmp(cmd, "KILL")) {
			User *u = finduser(origin);
			Server *s;
			char *rest;
			cmd = strtok(NULL, " ");
			if (u) {
				u->server->stats->operkills++;
				DelUser(cmd);
				rest = strtok(NULL, " ");
				rest = strtok(NULL,"");
				notice("\2OperKill:\2 %s Has Killed \2%s\2 for %s",origin,cmd,rest);
			} else {
				s = findserver(origin);
				rest = strtok(NULL, " ");
				rest = strtok(NULL,"");
				notice("\2ServerKill: \2 %s Has Killed \2%s\2 for %s",origin,cmd,rest);
				DelUser(cmd);
				if (s)
				s->stats->serverkills++;
			}

			if (!strcasecmp(cmd, s_StatServ)) {
				sts(":%s QUIT %s : Was Killed",me.name,s_StatServ); 
				init_statserv();
			} else if (!strcasecmp(cmd, s_Spam)) 
				init_spam();
		} else if (!strcmp(cmd, "PONG")) {
			Server *s;
			cmd = strtok(NULL, " ");
			s = findserver(cmd);
			if (s) {
				s->ping = time(NULL) - ping.last_sent;
				if (ping.ulag > 1)
					s->ping -= (float) ping.ulag;
				if (!strcmp(me.s->name, s->name))
					ping.ulag = me.s->ping;
				if (s->ping > s->highest_ping) {
					s->highest_ping = s->ping;
					s->t_highest_ping = time(NULL);
				} else if (s->ping < s->lowest_ping) {
					s->lowest_ping = s->ping;
					s->t_lowest_ping = time(NULL);
				}
				if (s->ping > me.lag_time) {
					globops(s_StatServ,"Oh Oh, \2%s\2 is Lagged out with a Ping of %d",s->name,s->ping);
				}
			} else {
				log("Received PONG from unknown server: %s", cmd);
			}
			if (me.noticelag==1) {
				notice("\2LAG:\2 %s is Lagged out with a Ping of %d",s->name,s->ping);
			}
		} else if (!strcmp(cmd, "AWAY")) {
			User *u = finduser(origin);
			if (u->is_away) {
				me.away--;
				u->is_away = 0;
			} else {
				me.away++;
				u->is_away = 1;
			}
		} else if (!strcmp(cmd, "NICK")) {
			User *u = finduser(origin);
			if (u) {
				cmd = strtok(NULL, " ");
				Change_User(u, cmd);
				notice("\2Nick Change\2 \2%s\2 Has Changed Their Nick to: %s",origin,cmd);
			}
		} else if (!strcmp(cmd, "KICK")) {
			User *u = finduser(origin);
				cmd = strtok(NULL, " ");
				cmd = strtok(NULL, " ");
			log(cmd);	
			if (u && !strcasecmp(s_StatServ,cmd)) {
				globops(s_StatServ,"Oi, I got Kicked from The Services Chan: %s by %s, Rejoining!",me.chan,u->nick);
				sts(":%s JOIN %s",s_StatServ,me.chan);
				sts(":%s MODE %s +o %s",me.name,me.chan,s_StatServ);
			}
		} else if (!strcmp(cmd, "JOIN")) {
			User *u = finduser(origin);
			if (u) {
				cmd = strtok(NULL, " ");
				if (*cmd == ':')
					cmd++;
				if (u->is_invis) {
					notice("\2INVISIBLE JOIN\2 \2%s\2 has Joined the Channel %s",origin,cmd);
				}
				if (me.onchan && !strcasecmp(cmd,me.chan) && u->is_oper == 1) {
					sts(":%s NOTICE %s :Welcome to %s, %s. For Help Type /msg %s help",s_StatServ,u->nick,me.chan,u->nick,s_StatServ);
					sts(":%s MODE %s +o %s",s_StatServ,me.chan,u->nick);
				} else if (!strcasecmp(cmd,me.chan) && u->is_oper == 0) {
					notice("This Channel is a Operators Channel Only, Please Leave the Channel %s",u->nick);
					sts(":%s NOTICE %s :The Channel %s is a Operators Only Channel, Please Leave now",s_StatServ,u->nick,me.chan);
				}
			}
		} else if (!strcmp(cmd, "PART")) {
			User *u = finduser(origin);
			if (u) {
				cmd = strtok(NULL, " ");
				if (u->is_invis) {
					notice("\2INVISIBLE PART\2 \2%s\2 has Parted the Channel %s",origin,cmd);
				}
			}
		} else {
			sendcoders(coreLine);
		}

	} else {
		if (!strcmp(origin, "PING")) {
			sts("PONG %s", cmd);
		} else if (!strcmp(origin, "NETINFO")) {
			me.onchan = 1;
			sts(":%s SVSMODE %s +Sq",s_StatServ,s_StatServ ,me.chan);
			sts(":%s NETINFO %d %d %s 0 0 0 0 :%s",me.name,me.maxusers,time(NULL),protocol_version,me.netname);
			globops(me.name,"Link with Network \2Complete!\2");
			globops(me.name,"Spam User is %s",s_Spam);
		} else if (!strcmp(origin, "PASS")) {
			init_statserv();
			init_spam();
		} else if (!strcmp(origin, "SERVER")) {
			Server *s;
			AddServer(cmd, 1);
			s = findserver(cmd);
			me.s = s;
		} else if (!strcmp(origin, "SQUIT")) {
			Server *s = findserver(cmd);
			if (s) s->stats->numsplits++;
			DelServer(cmd);
			notice("\2Possible NetSplit at: %s -> %s (Split)\2",origin,cmd);
		} else if (!strcmp(origin, "NICK")) {
			char *user, *host, *server;
			user = strtok(NULL, " ");
			user = strtok(NULL, " ");
			user = strtok(NULL, " ");
			host = strtok(NULL, " ");
			server = strtok(NULL, " ");
			AddUser(cmd, user, host, server);
			notice("\2SIGNON\2 \2%s\2(%s@%s) at: %s",cmd,user,host,server);
		} else if (!strcmp(origin, "SVSNICK")) {
			char *nnick;
			User *u;

			nnick = strtok(NULL, " ");
			u = finduser(nnick);
			nnick = strtok(NULL, " ");
			Change_User(u, nnick);
			notice("\2SVSNICK\2 \2%s\2 Has Changed Their Nick to: %s",u,nnick);
		} else if (!strcmp(origin, "KILL")) {
			char *user, *rest;
			user = strtok(NULL, " ");
			rest = strtok(NULL, " ");
			notice("\2KILL\2 \2%s\2 Got Killed by %s (s%)",cmd,user,rest);
		} else {
			sendcoders(coreLine);
		}
	}
	free(coreLine);
}

void privmsg(char *to, const char *from, char *fmt, ...)
{
	va_list ap;
	char buf[512], buf2[512];

	va_start(ap, fmt);
	vsnprintf(buf2, sizeof(buf2), fmt, ap);
	if (me.want_privmsg)
		sprintf(buf, ":%s PRIVMSG %s :%s", from, to, buf2);
	else
		sprintf(buf, ":%s NOTICE %s :%s", from, to, buf2);
	sts("%s", buf);
	va_end(ap);
}

void privmsg_list(char *to, char *from, const char **text)
{
	while (*text) {
		if (**text)
			privmsg(to, from, "%s", *text);
		else
			privmsg(to, from, " ");
		text++;
	}	
}

void globops(char *from, char *fmt, ...)
{
	va_list ap;
	char buf[512], buf2[512];

	va_start(ap, fmt);
	vsnprintf(buf2, sizeof(buf2), fmt, ap);
	sprintf(buf, ":%s GLOBOPS :%s", from, buf2);
	sts("%s", buf);
	va_end(ap);
}

int flood(User *u)
{
	time_t current = time(NULL);

	if (current - u->t_flood > 10) {
		u->t_flood = time(NULL);
		u->flood = 0;
		return 0;
	}
	if (u->flood >= 5) {
		sts(":%s KILL %s :%s!%s (Flooding Services.)", s_StatServ,
			u->nick, StatServ.host, s_StatServ);
		log("FLOODING: %s!%s@%s", u->nick, u->username, u->hostname);
		DelUser(u->nick);
		return 1;
	} else {
		u->flood++;
	}
	return 0;
}

static void ShowMOTD(char *nick)
{
	static unsigned char copyright[38] = {  /* Can you tell I was bored? */
	0x47, 0x65, 0x6f, 0x53, 0x74, 0x61, 0x74, 0x73, 0x20, 0x61, 0x72, 0x65,
	0x20, 0x28, 0x63, 0x29, 0x20, 0x31, 0x39, 0x39, 0x39, 0x20, 0x4a, 0x6f,
	0x6e, 0x61, 0x74, 0x68, 0x61, 0x6e, 0x20, 0x47, 0x65, 0x6f, 0x72, 0x67,
	0x65, 0x0
	};

	/* Removal or modification of this function is against the law.
	** Be nice, and don't remove it or modify it.
	** -Jonathan 'netgod' George (net@lite.net) */

	sts(":%s 375 %s :- %s Message of the Day", me.name, nick, me.name);
	sts(":%s 372 %s :- ", me.name, nick);
	sts(":%s 372 %s :- Origonal Version Copyright:", me.name, nick);
	sts(":%s 372 %s :- %s", me.name, nick, copyright);
	sts(":%s 372 %s :- Grab your copy at codebase.kamserve.com", me.name, nick);
	sts(":%s 376 %s :End of /MOTD command.", me.name, nick);
}
static void Showcredits(char *nick)
{

	sts(":%s 351 %s :- %s Credits ", me.name, nick, version);
	sts(":%s 351 %s :- This Version of %s was based on GeoStats-1.1.0", me.name, nick, version);
	sts(":%s 351 %s :- Originally Written by Jonathan 'netgod' George (net@lite.net)", me.name, nick);
	sts(":%s 351 %s :- Now Maintained by Fish (fish@dynam.ac) and Shmad (Shmad@kamserve.com)", me.name, nick);
	sts(":%s 351 %s :- For Support, you can find Fish at irc.global-irc.net", me.name, nick);
	sts(":%s 351 %s :- or Shmad at irc.dreaming.org", me.name, nick);
	sts(":%s 351 %s :- Thanks to:", me.name, nick);
	sts(":%s 351 %s :- Stskeeps for Writting the best IRCD ever!", me.name, nick);
	sts(":%s 351 %s :- the Users of Global-irc.net and Dreaming.org for being our Guinea Pigs!", me.name, nick);
}
